GrobLat Class Reference

A lattice with associated Grobner basis/neighbors. More...

`#include <LatticeAlgs.h>`

## Public Member Functions

| GrobLat (const Matrix &matrix, const SatBinomIdeal &ideal)
Neighbor | getNeighbor (size_t row) const
size_t | getNeighborCount () const
const Matrix & | getYMatrix () const
const Matrix & | getHMatrix () const
const Matrix & | getMatrix () const
const SatBinomIdeal & | getIdeal () const
Neighbor | getSum (Neighbor a, Neighbor b) const
Neighbor | getSum (size_t a, size_t b) const
size_t | getYDim () const
size_t | getHDim () const
bool | hasZeroEntryY () const
void | getInitialIdeal (BigIdeal &ideal) const
bool | isSum (Neighbor n) const
const vector< Neighbor > & | getNonSums () const
const mpq_class & | getZero () const
bool | isPointFreeBody (Neighbor a, Neighbor b) const
| Returns true if the smallest body containing zero, a and b has no neighbor in its interior.
bool | isPointFreeBody (Neighbor a, Neighbor b, Neighbor c) const
| Returns true if the smallest body containing zero, a, b and c has no neighbor in its interior.
bool | isInterior (Neighbor a, Neighbor b) const

## Private Attributes

vector< bool > | _isSumRow
vector< Neighbor > | _nonSums
Matrix | _y
Matrix | _h
Matrix | _mat
SatBinomIdeal | _ideal
mpq_class | _zero

## Detailed Description

A lattice with associated Grobner basis/neighbors.

Definition at line 124 of file LatticeAlgs.h.

## Constructor & Destructor Documentation

## GrobLat()

GrobLat::GrobLat | ( | const Matrix & | matrix,
|  | const SatBinomIdeal & | ideal )

Definition at line 1533 of file LatticeAlgs.cpp.

## Member Function Documentation

## getHDim()

size_t GrobLat::getHDim | ( |  | ) | const

inline

Definition at line 179 of file LatticeAlgs.h.

## getHMatrix()

const Matrix & GrobLat::getHMatrix | ( |  | ) | const

inline

Definition at line 139 of file LatticeAlgs.h.

## getIdeal()

const SatBinomIdeal & GrobLat::getIdeal | ( |  | ) | const

inline

Definition at line 142 of file LatticeAlgs.h.

## getInitialIdeal()

void GrobLat::getInitialIdeal | ( | BigIdeal & | ideal | ) | const

inline

Definition at line 187 of file LatticeAlgs.h.

## getMatrix()

const Matrix & GrobLat::getMatrix | ( |  | ) | const

inline

Definition at line 140 of file LatticeAlgs.h.

## getNeighbor()

Neighbor GrobLat::getNeighbor | ( | size_t | row | ) | const

inline

Definition at line 128 of file LatticeAlgs.h.

## getNeighborCount()

size_t GrobLat::getNeighborCount | ( |  | ) | const

inline

Definition at line 133 of file LatticeAlgs.h.

## getNonSums()

const vector< Neighbor > & GrobLat::getNonSums | ( |  | ) | const

inline

Definition at line 197 of file LatticeAlgs.h.

## getSum() [1/2]

Neighbor GrobLat::getSum | ( | Neighbor | a,
|  | Neighbor | b ) const

inline

Definition at line 144 of file LatticeAlgs.h.

## getSum() [2/2]

Neighbor GrobLat::getSum | ( | size_t | a,
|  | size_t | b ) const

inline

Definition at line 159 of file LatticeAlgs.h.

## getYDim()

size_t GrobLat::getYDim | ( |  | ) | const

inline

Definition at line 174 of file LatticeAlgs.h.

## getYMatrix()

const Matrix & GrobLat::getYMatrix | ( |  | ) | const

inline

Definition at line 138 of file LatticeAlgs.h.

## getZero()

const mpq_class & GrobLat::getZero | ( |  | ) | const

inline

Definition at line 198 of file LatticeAlgs.h.

## hasZeroEntryY()

bool GrobLat::hasZeroEntryY | ( |  | ) | const

inline

Definition at line 183 of file LatticeAlgs.h.

## isInterior()

bool GrobLat::isInterior | ( | Neighbor | a,
|  | Neighbor | b ) const

inline

Definition at line 215 of file LatticeAlgs.h.

## isPointFreeBody() [1/2]

bool GrobLat::isPointFreeBody | ( | Neighbor | a,
|  | Neighbor | b ) const

inline

Returns true if the smallest body containing zero, a and b has no neighbor in its interior.

Definition at line 202 of file LatticeAlgs.h.

## isPointFreeBody() [2/2]

bool GrobLat::isPointFreeBody | ( | Neighbor | a,
|  | Neighbor | b,
|  | Neighbor | c ) const

inline

Returns true if the smallest body containing zero, a, b and c has no neighbor in its interior.

Definition at line 209 of file LatticeAlgs.h.

## isSum()

bool GrobLat::isSum | ( | Neighbor | n | ) | const

inline

Definition at line 191 of file LatticeAlgs.h.

## Member Data Documentation

## _h

Matrix GrobLat::_h

private

Definition at line 229 of file LatticeAlgs.h.

## _ideal

SatBinomIdeal GrobLat::_ideal

private

Definition at line 231 of file LatticeAlgs.h.

## _isSumRow

vector<bool> GrobLat::_isSumRow

private

Definition at line 225 of file LatticeAlgs.h.

## _mat

Matrix GrobLat::_mat

private

Definition at line 230 of file LatticeAlgs.h.

## _nonSums

vector<Neighbor> GrobLat::_nonSums

private

Definition at line 226 of file LatticeAlgs.h.

## _y

Matrix GrobLat::_y

private

Definition at line 228 of file LatticeAlgs.h.

## _zero

mpq_class GrobLat::_zero

private

Definition at line 232 of file LatticeAlgs.h.

The documentation for this class was generated from the following files:

- src/LatticeAlgs.h
- src/LatticeAlgs.cpp